treatfile:- read(Termo), treat(Termo).
treat( end_of_file ) :- !.
treat(Term) :- treatterm(Term), treatfile.
treatterm(Term) :- write(Term).

open_file(F) :-
  open(F, read, ID),  % open a stream
  repeat,             % try again forever
  read(ID, X),        % read from the stream
  write(X), nl,       % write to current output stream
  X == end_of_file,   % fail (backtrack) if not end of file
  close(ID).          % close the file

%sum_file(F, Sum) :-
%  open(F, read, ID),  % open a stream
%  repeat,             % try again forever
%  read(ID, X),        % read from the stream
%  soma(X, Sum, Sum2),
%  Sum is Sum2,
%  write(Sum),
%  flush(), 
%  nl,       % write to current output stream
%  X == end_of_file,!,   % fail (backtrack) if not end of file
%  close(ID).          % close the file

%soma(end_of_line, Y, Z):- Z is Y, !.
%soma(X,Y,Z) :- Z is X+Y .

soma([], X, X). 
soma([H|T], X, Y) :- soma(T, X, Z), Y is H + Z.
